*!* Tests from cbc_e_m.txt according to info in katmct.pdf
*!* all tests check out for VFPEncryption FLL
CLEAR ALL

LOCAL lcKey, lcPlaintext, lcIV, lcCiphertext, lcChainValue, lcInputBlock, lcPrevCiphertext, lnEncType
LOCAL i, j, lnKeySize

SET LIBRARY TO (LOCFILE("vfpencryption71.fll", "FLL"))
SET ESCAPE ON
CLEAR

FOR m.lnKeySize = 16 TO 32 STEP 8 && 128, 192, 256
	m.lnEncType = ICASE(m.lnKeySize = 16, 0, m.lnKeySize = 24, 1, m.lnKeySize = 32, 2)
	m.lcKey = STRCONV(REPLICATE("0",m.lnKeySize * 2),16)
	m.lcPlaintext = STRCONV("00000000000000000000000000000000",16)
	m.lcIV = STRCONV("00000000000000000000000000000000",16)
	m.lcCiphertext = ""
	m.lcChainValue = ""
	? "=========="
	? "KEYSIZE=" + TRANSFORM(m.lnKeySize * 8) && in bits
	?
	FOR m.i = 0 TO 399
		IF (m.i==0)
			m.lcChainValue = m.lcIV
		ENDIF
		?"I=" + TRANSFORM(m.i)
		?"KEY=" + STRCONV(m.lcKey, 15)
		?"IV=" + STRCONV(m.lcChainValue, 15)
		?"PT=" + STRCONV(m.lcPlaintext, 15)
		FOR j = 0 TO 9999
			m.lcInputBlock = CAST(BITXOR(CREATEBINARY(m.lcPlaintext), CREATEBINARY(m.lcChainValue)) AS M)
			m.lcPrevCiphertext = m.lcCiphertext
			m.lcCiphertext = ENCRYPT(m.lcInputBlock, m.lcKey, m.lnEncType, 1, 0, m.lnKeySize, 16, m.lcIV)
			IF m.j = 0
				m.lcPlaintext = m.lcChainValue
			ELSE
				m.lcPlaintext = m.lcPrevCiphertext
			ENDIF
			m.lcChainValue = m.lcCiphertext
		ENDFOR
		?"CT=" + STRCONV(m.lcCiphertext, 15)
		?
		m.lcKey = CAST(BITXOR(CREATEBINARY(m.lcKey), CREATEBINARY(LEFT(Right(m.lcPrevCiphertext, LEN(m.lcKey) - LEN(m.lcCiphertext)) + m.lcCiphertext, m.lnKeySize))) AS M)
		m.lcPlaintext = m.lcPrevCiphertext
		m.lcChainValue = m.lcCiphertext
		SET STEP ON
	ENDFOR
	SET STEP ON
ENDFOR
SET LIBRARY TO
